Index: configure.in
===================================================================
--- configure.in	(revision 66075)
+++ configure.in	(working copy)
@@ -277,6 +277,12 @@
                           e.g. '--with-liblas=/usr/local/bin/liblas-config',
                           default: no)],, with_liblas="no")
 
+AC_ARG_WITH(pdal,
+[  --with-pdal[=path/pdal-config]
+                          enable PDAL support (pdal-config with path,
+                          e.g. '--with-pdal=/usr/local/bin/pdal-config',
+                          default: no)],, with_pdal="no")
+
 AC_ARG_WITH(wxwidgets,
 [  --with-wxwidgets[=path/wx-config]
                           enable wxWidgets support (wx-config with path,
@@ -823,6 +829,59 @@
 AC_SUBST(LIBLAS_INC)
 AC_SUBST(USE_LIBLAS)
 
+# PDAL option
+
+AC_MSG_CHECKING(whether to use PDAL)
+
+PDAL_LIBS=
+PDAL_CFLAGS=
+USE_PDAL=
+
+if test "`basename xx/$with_pdal`" = "pdal-config" ; then
+  PDAL_CONFIG="$with_pdal"
+fi
+
+if test "$with_pdal" = "no" ; then
+  AC_MSG_RESULT(no)
+else
+  AC_MSG_RESULT(yes)
+  AC_PATH_PROG(PDAL_CONFIG, pdal-config, no)
+
+  if test "$PDAL_CONFIG" = "no" ; then
+    AC_MSG_ERROR([*** could not find pdal-config])
+  fi
+
+  if test "$PDAL_CONFIG" != "" ; then
+    PDAL_LIBS=`"$PDAL_CONFIG" --libs`
+    PDAL_CFLAGS=`"$PDAL_CONFIG" --cflags`
+    PDAL_INC=`"$PDAL_CONFIG" --includes`
+    USE_PDAL=1
+  fi
+
+  PDAL=
+  ac_save_libs="$LIBS"
+  ac_save_cflags="$CFLAGS"
+  ac_save_cppflags="$CPPFLAGS"
+  LIBS="$LIBS $PDAL_LIBS"
+  CFLAGS="$CFLAGS $PDAL_CFLAGS"
+  CPPFLAGS="$CPPFLAGS $PDAL_INC"
+  AC_TRY_LINK([#include <string.h>],[int a = 1;],,[
+  AC_TRY_LINK([#include <string.h>],[int a = 1;],LAS_LIBS="$LAS_LIBS",[
+  AC_MSG_ERROR([*** Unable to locate PDAL library.])
+  ])
+  ])
+  LIBS=${ac_save_libs}
+  CFLAGS=${ac_save_cflags}
+  CPPFLAGS=${ac_save_cppflags}
+
+  AC_DEFINE(HAVE_PDAL)
+fi
+
+AC_SUBST(PDAL_LIBS)
+AC_SUBST(PDAL_CFLAGS)
+AC_SUBST(PDAL_INC)
+AC_SUBST(USE_PDAL)
+
 # NetCDF option
 
 AC_MSG_CHECKING(whether to use NetCDF)
@@ -1905,6 +1964,7 @@
 LOC_MSG_USE(LAPACK support,USE_LAPACK)
 LOC_MSG_USE(Large File support (LFS), USE_LARGEFILES)
 LOC_MSG_USE(libLAS support,USE_LIBLAS)
+LOC_MSG_USE(PDAL support,USE_PDAL)
 LOC_MSG_USE(MySQL support,USE_MYSQL)
 LOC_MSG_USE(NetCDF support,USE_NETCDF)
 LOC_MSG_USE(NLS support,USE_NLS)
Index: include/Make/Platform.make.in
===================================================================
--- include/Make/Platform.make.in	(revision 66075)
+++ include/Make/Platform.make.in	(working copy)
@@ -168,6 +168,12 @@
 LASINC              = @LIBLAS_INC@
 USE_LIBLAS          = @USE_LIBLAS@
 
+#LAS LiDAR through PDAL
+PDALLIBS             = @PDAL_LIBS@
+PDALCFLAGS           = @PDAL_CFLAGS@
+PDALINC              = @PDAL_INC@
+USE_PDAL             = @USE_PDAL@
+
 #GEOS
 GEOSLIBS            = @GEOS_LIBS@
 GEOSCFLAGS          = @GEOS_CFLAGS@
Index: vector/Makefile
===================================================================
--- vector/Makefile	(revision 66075)
+++ vector/Makefile	(working copy)
@@ -98,6 +98,7 @@
 	v.external \
 	v.in.dwg \
 	v.in.lidar \
+	v.in.pointcloud \
 	v.external.out
 
 include $(MODULE_TOPDIR)/include/Make/Dir.make
Index: vector/v.in.pointcloud/Makefile
===================================================================
--- vector/v.in.pointcloud/Makefile	(revision 66075)
+++ vector/v.in.pointcloud/Makefile	(working copy)
@@ -1,16 +1,19 @@
 MODULE_TOPDIR = ../..
 
-PGM=v.in.lidar
+PGM=v.in.pointcloud
 
-LIBES = $(GPROJLIB) $(VECTORLIB) $(DBMILIB) $(GISLIB) $(LASLIBS) $(MATHLIB)
+LIBES = $(GPROJLIB) $(VECTORLIB) $(DBMILIB) $(GISLIB) $(MATHLIB) $(PDALLIBS)
 DEPENDENCIES = $(GPROJDEP) $(VECTORDEP) $(DBMIDEP) $(GISDEP)
 
-EXTRA_INC = $(VECT_INC) $(PROJINC) $(LASINC)
-EXTRA_CFLAGS = $(VECT_CFLAGS)
+EXTRA_INC = $(VECT_INC) $(PROJINC) $(PDALINC)
+EXTRA_CFLAGS = $(VECT_CFLAGS) -std=c++11
 
 include $(MODULE_TOPDIR)/include/Make/Module.make
 
-ifneq ($(USE_LIBLAS),)
+LINK = $(CXX)
+
+ifneq ($(strip $(CXX)),)
+ifneq ($(USE_PDAL),)
 default: cmd
 endif
-
+endif
Index: vector/v.in.pointcloud/main.cpp
===================================================================
--- vector/v.in.pointcloud/main.cpp	(revision 66075)
+++ vector/v.in.pointcloud/main.cpp	(working copy)
@@ -1,37 +1,47 @@
 
 /****************************************************************
  *
- * MODULE:       v.in.lidar
+ * MODULE:       v.in.pointcloud
  *
- * AUTHOR(S):    Markus Metz
+ * AUTHOR(S):    Vaclav Petras
+ *               Markus Metz (v.in.lidar, libLAS-based implementation)
  *               based on v.in.ogr
  *
- * PURPOSE:      Import LiDAR LAS points
+ * PURPOSE:      Import LiDAR LAS points and other point clouds
  *
- * COPYRIGHT:    (C) 2011-2014 by the GRASS Development Team
+ * COPYRIGHT:    (C) 2011-2015 by the GRASS Development Team
  *
  *               This program is free software under the
  *               GNU General Public License (>=v2).
  *               Read the file COPYING that comes with GRASS
  *               for details.
- *
- * TODO: - make fixed field length of OFTIntegerList dynamic
- *       - several other TODOs below
 **************************************************************/
 
-#include <stdlib.h>
-#include <string.h>
-#include <unistd.h>
+#include <memory>
+#include <iostream>
+#include <typeinfo>
+
+#include <pdal/PointTable.hpp>
+#include <pdal/PointView.hpp>
+#include <pdal/StageFactory.hpp>
+#include <pdal/LasReader.hpp>
+#include <pdal/LasHeader.hpp>
+#include <pdal/Options.hpp>
+
+extern "C"
+{
 #include <grass/gis.h>
+#include <grass/glocale.h>
+#include <grass/gis.h>
 #include <grass/dbmi.h>
 #include <grass/vector.h>
 #include <grass/gprojects.h>
 #include <grass/glocale.h>
-#include <liblas/capi/liblas.h>
+}
 
 #ifndef MAX
-#  define MIN(a,b)      ((a<b) ? a : b)
-#  define MAX(a,b)      ((a>b) ? a : b)
+#define MIN(a,b)      ((a<b) ? a : b)
+#define MAX(a,b)      ((a>b) ? a : b)
 #endif
 
 #define LAS_ALL 0
@@ -64,14 +74,14 @@
  *                         above classification table.
  *    5 | Synthetic      | If set then this point was created by a technique
  *                         other than LIDAR collection such as digitized from
- *	                   a photogrammetric stereo model or by traversing
+ *                           a photogrammetric stereo model or by traversing
  *                         a waveform.
- *    6 | Key-point      | If set, this point is considered to be a model 
+ *    6 | Key-point      | If set, this point is considered to be a model
  *                         key-point and thus generally should not be withheld
  *                         in a thinning algorithm.
  *    7 | Withheld       | If set, this point should not be included in
  *                         processing (synonymous with Deleted).
-*/
+ */
 
 struct class_table
 {
@@ -93,7 +103,7 @@
     {10, "Reserved for ASPRS Definition"},
     {11, "Reserved for ASPRS Definition"},
     {12, "Overlap Points"},
-    {13 /* 13 - 31 */, "Reserved for ASPRS Definition"},
+    {13 /* 13 - 31 */ , "Reserved for ASPRS Definition"},
     {0, 0}
 };
 
@@ -104,7 +114,7 @@
     {0, 0}
 };
 
-void print_lasinfo(LASHeaderH LAS_header, LASSRSH LAS_srs);
+//void print_lasinfo(LASHeaderH LAS_header, LASSRSH LAS_srs);
 
 int main(int argc, char *argv[])
 {
@@ -130,24 +140,20 @@
     struct field_info *Fi;
     dbDriver *driver;
     dbString sql, strval;
-    
+
     /* LAS */
-    LASReaderH LAS_reader;
-    LASHeaderH LAS_header;
-    LASSRSH LAS_srs;
-    LASPointH LAS_point;
     double scale_x, scale_y, scale_z, offset_x, offset_y, offset_z;
-    int las_point_format;
     int have_time, have_color;
     int return_filter;
     int skipme;
     int point_class;
-    unsigned int not_valid;	
+    unsigned int not_valid;
 
     struct line_pnts *Points;
     struct line_cats *Cats;
 
-    unsigned int n_features, feature_count, n_outside, n_filtered, n_class_filtered;
+    unsigned int n_features, feature_count, n_outside, n_filtered,
+        n_class_filtered;
     int overwrite;
 
     G_gisinit(argv[0]);
@@ -156,14 +162,16 @@
     G_add_keyword(_("vector"));
     G_add_keyword(_("import"));
     G_add_keyword(_("LIDAR"));
-    module->description = _("Converts LAS LiDAR point clouds to a GRASS vector map with libLAS.");
+    module->description =
+        _("Converts LAS LiDAR point clouds to a GRASS vector map with PDAL.");
 
     in_opt = G_define_standard_option(G_OPT_F_INPUT);
     in_opt->label = _("LAS input file");
-    in_opt->description = _("LiDAR input files in LAS format (*.las or *.laz)");
+    in_opt->description =
+        _("LiDAR input files in LAS format (*.las or *.laz)");
 
     out_opt = G_define_standard_option(G_OPT_V_OUTPUT);
-    
+
     spat_opt = G_define_option();
     spat_opt->key = "spatial";
     spat_opt->type = TYPE_DOUBLE;
@@ -173,7 +181,7 @@
     spat_opt->label = _("Import subregion only");
     spat_opt->guisection = _("Subregion");
     spat_opt->description =
-	_("Format: xmin,ymin,xmax,ymax - usually W,S,E,N");
+        _("Format: xmin,ymin,xmax,ymax - usually W,S,E,N");
 
     outloc_opt = G_define_option();
     outloc_opt->key = "location";
@@ -181,7 +189,7 @@
     outloc_opt->required = NO;
     outloc_opt->description = _("Name for new location to create");
     outloc_opt->key_desc = "name";
-    
+
     filter_opt = G_define_option();
     filter_opt->key = "return_filter";
     filter_opt->type = TYPE_STRING;
@@ -201,10 +209,9 @@
 
     print_flag = G_define_flag();
     print_flag->key = 'p';
-    print_flag->description =
-	_("Print LAS file info and exit");
+    print_flag->description = _("Print LAS file info and exit");
     print_flag->suppress_required = YES;
-    
+
     notab_flag = G_define_standard_flag(G_FLG_V_TABLE);
     notab_flag->guisection = _("Attributes");
 
@@ -211,9 +218,9 @@
     over_flag = G_define_flag();
     over_flag->key = 'o';
     over_flag->label =
-	_("Override projection check (use current location's projection)");
+        _("Override projection check (use current location's projection)");
     over_flag->description =
-	_("Assume that the dataset has same projection as the current location");
+        _("Assume that the dataset has same projection as the current location");
 
     region_flag = G_define_flag();
     region_flag->key = 'r';
@@ -223,12 +230,12 @@
     extend_flag = G_define_flag();
     extend_flag->key = 'e';
     extend_flag->description =
-	_("Extend region extents based on new dataset");
+        _("Extend region extents based on new dataset");
 
     no_import_flag = G_define_flag();
     no_import_flag->key = 'i';
     no_import_flag->description =
-	_("Create the location specified by the \"location\" parameter and exit."
+        _("Create the location specified by the \"location\" parameter and exit."
           " Do not import the vector data.");
     no_import_flag->suppress_required = YES;
 
@@ -240,97 +247,102 @@
     overwrite = G_check_overwrite(argc, argv);
 
     if (G_parser(argc, argv))
-	exit(EXIT_FAILURE);
+        return EXIT_FAILURE;
 
     /* Don't crash on cmd line if file not found */
     if (access(in_opt->answer, F_OK) != 0) {
-	G_fatal_error(_("Input file <%s> does not exist"), in_opt->answer);
+        G_fatal_error(_("Input file <%s> does not exist"), in_opt->answer);
     }
-    /* Open LAS file*/
-    LAS_reader = LASReader_Create(in_opt->answer);
-    LAS_header = LASReader_GetHeader(LAS_reader);
+    /* Open LAS file */
+    pdal::Option las_opt("filename", in_opt->answer);
+    pdal::Options las_opts;
+    las_opts.add(las_opt);
+    pdal::StageFactory f;
+    pdal::PointTable table;
+    pdal::LasReader las_reader;
+    las_reader.setOptions(las_opts);
+    las_reader.prepare(table);
+    pdal::PointViewSet point_view_set = las_reader.execute(table);
+    pdal::PointViewPtr point_view = *point_view_set.begin();
 
-    if  (LAS_header == NULL) {
-	G_fatal_error(_("Input file <%s> is not a LAS LiDAR point cloud"),
-	                in_opt->answer);
-    }
+    pdal::LasHeader las_header = las_reader.header();
 
-    LAS_srs = LASHeader_GetSRS(LAS_header);
+    // must be set by user
+    // LAS_srs = LASHeader_GetSRS(LAS_header);
 
-    scale_x = LASHeader_GetScaleX(LAS_header);
-    scale_y = LASHeader_GetScaleY(LAS_header);
-    scale_z = LASHeader_GetScaleZ(LAS_header);
+    scale_x = las_header.scaleX();
+    scale_y = las_header.scaleY();
+    scale_z = las_header.scaleZ();
 
-    offset_x = LASHeader_GetOffsetX(LAS_header);
-    offset_y = LASHeader_GetOffsetY(LAS_header);
-    offset_z = LASHeader_GetOffsetZ(LAS_header);
+    offset_x = las_header.offsetX();
+    offset_y = las_header.offsetY();
+    offset_z = las_header.offsetZ();
 
-    xmin = LASHeader_GetMinX(LAS_header);
-    xmax = LASHeader_GetMaxX(LAS_header);
-    ymin = LASHeader_GetMinY(LAS_header);
-    ymax = LASHeader_GetMaxY(LAS_header);
+    xmin = las_header.minX();
+    xmax = las_header.maxX();
+    ymin = las_header.minY();
+    ymax = las_header.maxY();
 
     /* Print LAS header */
     if (print_flag->answer) {
-	/* print... */
-	print_lasinfo(LAS_header, LAS_srs);
-
-	LASSRS_Destroy(LAS_srs);
-	LASHeader_Destroy(LAS_header);
-	LASReader_Destroy(LAS_reader);
-
-	exit(EXIT_SUCCESS);
+        /* print... */
+        // quick implementation using PDAL's output
+        std::cout << las_header << "Spatial reference (WKT):" << std::endl
+            << table.spatialRef() << std::endl;
+        // we return rather then exit to call destructors
+        return EXIT_SUCCESS;
     }
 
     return_filter = LAS_ALL;
     if (filter_opt->answer) {
-	if (strcmp(filter_opt->answer, "first") == 0)
-	    return_filter = LAS_FIRST;
-	else if (strcmp(filter_opt->answer, "last") == 0)
-	    return_filter = LAS_LAST;
-	else if (strcmp(filter_opt->answer, "mid") == 0)
-	    return_filter = LAS_MID;
-	else
-	    G_fatal_error(_("Unknown filter option <%s>"), filter_opt->answer);
+        if (strcmp(filter_opt->answer, "first") == 0)
+            return_filter = LAS_FIRST;
+        else if (strcmp(filter_opt->answer, "last") == 0)
+            return_filter = LAS_LAST;
+        else if (strcmp(filter_opt->answer, "mid") == 0)
+            return_filter = LAS_MID;
+        else
+            G_fatal_error(_("Unknown filter option <%s>"), filter_opt->answer);
     }
 
     if (region_flag->answer) {
-	if (spat_opt->answer)
-	    G_fatal_error(_("Select either the current region flag or the spatial option, not both"));
+        if (spat_opt->answer)
+            G_fatal_error(_("Select either the current region flag or the spatial option, not both"));
 
-	G_get_window(&cur_wind);
-	xmin = cur_wind.west;
-	xmax = cur_wind.east;
-	ymin = cur_wind.south;
-	ymax = cur_wind.north;
+        G_get_window(&cur_wind);
+        xmin = cur_wind.west;
+        xmax = cur_wind.east;
+        ymin = cur_wind.south;
+        ymax = cur_wind.north;
     }
     if (spat_opt->answer) {
-	/* See as reference: gdal/ogr/ogr_capi_test.c */
+        /* See as reference: gdal/ogr/ogr_capi_test.c */
 
-	/* cut out a piece of the map */
-	/* order: xmin,ymin,xmax,ymax */
-	int arg_s_num = 0;
-	i = 0;
-	while (spat_opt->answers[i]) {
-	    if (i == 0)
-		xmin = atof(spat_opt->answers[i]);
-	    if (i == 1)
-		ymin = atof(spat_opt->answers[i]);
-	    if (i == 2)
-		xmax = atof(spat_opt->answers[i]);
-	    if (i == 3)
-		ymax = atof(spat_opt->answers[i]);
-	    arg_s_num++;
-	    i++;
-	}
-	if (arg_s_num != 4)
-	    G_fatal_error(_("4 parameters required for 'spatial' parameter"));
+        /* cut out a piece of the map */
+        /* order: xmin,ymin,xmax,ymax */
+        int arg_s_num = 0;
+        i = 0;
+        while (spat_opt->answers[i]) {
+            if (i == 0)
+                xmin = atof(spat_opt->answers[i]);
+            if (i == 1)
+                ymin = atof(spat_opt->answers[i]);
+            if (i == 2)
+                xmax = atof(spat_opt->answers[i]);
+            if (i == 3)
+                ymax = atof(spat_opt->answers[i]);
+            arg_s_num++;
+            i++;
+        }
+        if (arg_s_num != 4)
+            G_fatal_error(_("4 parameters required for 'spatial' parameter"));
     }
     if (spat_opt->answer || region_flag->answer) {
-	G_debug(2, "cut out with boundaries: xmin:%f ymin:%f xmax:%f ymax:%f",
-		xmin, ymin, xmax, ymax);
+        G_debug(2, "cut out with boundaries: xmin:%f ymin:%f xmax:%f ymax:%f",
+                xmin, ymin, xmax, ymax);
     }
 
+    // TODO: what is puprose of the following region?
     /* fetch boundaries */
     G_get_window(&cellhd);
     cellhd.north = ymax;
@@ -337,7 +349,7 @@
     cellhd.south = ymin;
     cellhd.west = xmin;
     cellhd.east = xmax;
-    cellhd.rows = 20;	/* TODO - calculate useful values */
+    cellhd.rows = 20;        /* TODO - calculate useful values */
     cellhd.cols = 20;
     cellhd.ns_res = (cellhd.north - cellhd.south) / cellhd.rows;
     cellhd.ew_res = (cellhd.east - cellhd.west) / cellhd.cols;
@@ -345,155 +357,158 @@
     /* Fetch input map projection in GRASS form. */
     proj_info = NULL;
     proj_units = NULL;
-    projstr = LASSRS_GetWKT_CompoundOK(LAS_srs);
+    projstr = table.spatialRef().getWKT(pdal::SpatialReference::eCompoundOK)
+        .c_str();
 
+    // TODO: replace by on-the-fly reprojection
     /* Do we need to create a new location? */
+
     if (outloc_opt->answer != NULL) {
-	/* Convert projection information non-interactively as we can't
-	 * assume the user has a terminal open */
-	if (GPJ_wkt_to_grass(&cellhd, &proj_info,
-			     &proj_units, projstr, 0) < 0) {
-	    G_fatal_error(_("Unable to convert input map projection to GRASS "
-			    "format; cannot create new location."));
-	}
-	else {
+        /* Convert projection information non-interactively as we can't
+         * assume the user has a terminal open */
+        if (GPJ_wkt_to_grass(&cellhd, &proj_info,
+                             &proj_units, projstr, 0) < 0) {
+            G_fatal_error(_("Unable to convert input map projection to GRASS "
+                            "format; cannot create new location."));
+        }
+        else {
             if (0 != G_make_location(outloc_opt->answer, &cellhd,
                                      proj_info, proj_units)) {
                 G_fatal_error(_("Unable to create new location <%s>"),
                               outloc_opt->answer);
             }
-	    G_message(_("Location <%s> created"), outloc_opt->answer);
-	}
+            G_message(_("Location <%s> created"), outloc_opt->answer);
+        }
 
         /* If the i flag is set, clean up? and exit here */
-        if(no_import_flag->answer)
-            exit(EXIT_SUCCESS);
+        if (no_import_flag->answer)
+            return EXIT_SUCCESS;
 
-	/*  TODO: */
-	G_warning("Import into new location not yet implemented");
-	/* at this point the module should be using G_create_alt_env()
-	    to change context to the newly created location; once done
-	    it should switch back with G_switch_env(). See r.in.gdal */
+        /*  TODO: */
+        G_warning("Import into new location not yet implemented");
+        /* at this point the module should be using G_create_alt_env()
+           to change context to the newly created location; once done
+           it should switch back with G_switch_env(). See r.in.gdal */
     }
     else {
-	int err = 0;
+        int err = 0;
 
-	/* Projection only required for checking so convert non-interactively */
-	if (GPJ_wkt_to_grass(&cellhd, &proj_info,
-			     &proj_units, projstr, 0) < 0)
-	    G_warning(_("Unable to convert input map projection information to "
-		       "GRASS format for checking"));
+        /* Projection only required for checking so convert non-interactively */
+        if (GPJ_wkt_to_grass(&cellhd, &proj_info,
+                             &proj_units, projstr, 0) < 0)
+            G_warning(_("Unable to convert input map projection information to "
+                       "GRASS format for checking"));
 
-	/* Does the projection of the current location match the dataset? */
-	/* G_get_window seems to be unreliable if the location has been changed */
-	G_get_default_window(&loc_wind);
-	/* fetch LOCATION PROJ info */
-	if (loc_wind.proj != PROJECTION_XY) {
-	    loc_proj_info = G_get_projinfo();
-	    loc_proj_units = G_get_projunits();
-	}
+        /* Does the projection of the current location match the dataset? */
+        /* G_get_window seems to be unreliable if the location has been changed */
+        G_get_default_window(&loc_wind);
+        /* fetch LOCATION PROJ info */
+        if (loc_wind.proj != PROJECTION_XY) {
+            loc_proj_info = G_get_projinfo();
+            loc_proj_units = G_get_projunits();
+        }
 
-	if (over_flag->answer) {
-	    cellhd.proj = loc_wind.proj;
-	    cellhd.zone = loc_wind.zone;
-	    G_message(_("Over-riding projection check"));
-	}
-	else if (loc_wind.proj != cellhd.proj
-		 || (err =
-		     G_compare_projections(loc_proj_info, loc_proj_units,
-					   proj_info, proj_units)) != TRUE) {
-	    int i_value;
+        if (over_flag->answer) {
+            cellhd.proj = loc_wind.proj;
+            cellhd.zone = loc_wind.zone;
+            G_message(_("Over-riding projection check"));
+        }
+        else if (loc_wind.proj != cellhd.proj
+                 || (err =
+                     G_compare_projections(loc_proj_info, loc_proj_units,
+                                           proj_info, proj_units)) != TRUE) {
+            int i_value;
 
-	    strcpy(error_msg,
-		   _("Projection of dataset does not"
-		     " appear to match current location.\n\n"));
+            strcpy(error_msg,
+                   _("Projection of dataset does not"
+                     " appear to match current location.\n\n"));
 
-	    /* TODO: output this info sorted by key: */
-	    if (loc_wind.proj != cellhd.proj || err != -2) {
-		if (loc_proj_info != NULL) {
-		    strcat(error_msg, _("GRASS LOCATION PROJ_INFO is:\n"));
-		    for (i_value = 0; i_value < loc_proj_info->nitems;
-			 i_value++)
-			sprintf(error_msg + strlen(error_msg), "%s: %s\n",
-				loc_proj_info->key[i_value],
-				loc_proj_info->value[i_value]);
-		    strcat(error_msg, "\n");
-		}
+            /* TODO: output this info sorted by key: */
+            if (loc_wind.proj != cellhd.proj || err != -2) {
+                if (loc_proj_info != NULL) {
+                    strcat(error_msg, _("GRASS LOCATION PROJ_INFO is:\n"));
+                    for (i_value = 0; i_value < loc_proj_info->nitems;
+                         i_value++)
+                        sprintf(error_msg + strlen(error_msg), "%s: %s\n",
+                                loc_proj_info->key[i_value],
+                                loc_proj_info->value[i_value]);
+                    strcat(error_msg, "\n");
+                }
 
-		if (proj_info != NULL) {
-		    strcat(error_msg, _("Import dataset PROJ_INFO is:\n"));
-		    for (i_value = 0; i_value < proj_info->nitems; i_value++)
-			sprintf(error_msg + strlen(error_msg), "%s: %s\n",
-				proj_info->key[i_value],
-				proj_info->value[i_value]);
-		}
-		else {
-		    strcat(error_msg, _("Import dataset PROJ_INFO is:\n"));
-		    if (cellhd.proj == PROJECTION_XY)
-			sprintf(error_msg + strlen(error_msg),
-				"Dataset proj = %d (unreferenced/unknown)\n",
-				cellhd.proj);
-		    else if (cellhd.proj == PROJECTION_LL)
-			sprintf(error_msg + strlen(error_msg),
-				"Dataset proj = %d (lat/long)\n",
-				cellhd.proj);
-		    else if (cellhd.proj == PROJECTION_UTM)
-			sprintf(error_msg + strlen(error_msg),
-				"Dataset proj = %d (UTM), zone = %d\n",
-				cellhd.proj, cellhd.zone);
-		    else
-			sprintf(error_msg + strlen(error_msg),
-				"Dataset proj = %d (unknown), zone = %d\n",
-				cellhd.proj, cellhd.zone);
-		}
-	    }
-	    else {
-		if (loc_proj_units != NULL) {
-		    strcat(error_msg, "GRASS LOCATION PROJ_UNITS is:\n");
-		    for (i_value = 0; i_value < loc_proj_units->nitems;
-			 i_value++)
-			sprintf(error_msg + strlen(error_msg), "%s: %s\n",
-				loc_proj_units->key[i_value],
-				loc_proj_units->value[i_value]);
-		    strcat(error_msg, "\n");
-		}
+                if (proj_info != NULL) {
+                    strcat(error_msg, _("Import dataset PROJ_INFO is:\n"));
+                    for (i_value = 0; i_value < proj_info->nitems; i_value++)
+                        sprintf(error_msg + strlen(error_msg), "%s: %s\n",
+                                proj_info->key[i_value],
+                                proj_info->value[i_value]);
+                }
+                else {
+                    strcat(error_msg, _("Import dataset PROJ_INFO is:\n"));
+                    if (cellhd.proj == PROJECTION_XY)
+                        sprintf(error_msg + strlen(error_msg),
+                                "Dataset proj = %d (unreferenced/unknown)\n",
+                                cellhd.proj);
+                    else if (cellhd.proj == PROJECTION_LL)
+                        sprintf(error_msg + strlen(error_msg),
+                                "Dataset proj = %d (lat/long)\n",
+                                cellhd.proj);
+                    else if (cellhd.proj == PROJECTION_UTM)
+                        sprintf(error_msg + strlen(error_msg),
+                                "Dataset proj = %d (UTM), zone = %d\n",
+                                cellhd.proj, cellhd.zone);
+                    else
+                        sprintf(error_msg + strlen(error_msg),
+                                "Dataset proj = %d (unknown), zone = %d\n",
+                                cellhd.proj, cellhd.zone);
+                }
+            }
+            else {
+                if (loc_proj_units != NULL) {
+                    strcat(error_msg, "GRASS LOCATION PROJ_UNITS is:\n");
+                    for (i_value = 0; i_value < loc_proj_units->nitems;
+                         i_value++)
+                        sprintf(error_msg + strlen(error_msg), "%s: %s\n",
+                                loc_proj_units->key[i_value],
+                                loc_proj_units->value[i_value]);
+                    strcat(error_msg, "\n");
+                }
 
-		if (proj_units != NULL) {
-		    strcat(error_msg, "Import dataset PROJ_UNITS is:\n");
-		    for (i_value = 0; i_value < proj_units->nitems; i_value++)
-			sprintf(error_msg + strlen(error_msg), "%s: %s\n",
-				proj_units->key[i_value],
-				proj_units->value[i_value]);
-		}
-	    }
-	    sprintf(error_msg + strlen(error_msg),
-		    _("\nIn case of no significant differences in the projection definitions,"
-		      " use the -o flag to ignore them and use"
-		      " current location definition.\n"),
-		    G_program_name());
-	    strcat(error_msg,
-		   _("Consider generating a new location with 'location' parameter"
-		    " from input data set.\n"));
-	    G_fatal_error(error_msg);
-	}
-	else {
-	    G_verbose_message(_("Projection of input dataset and current "
-				"location appear to match"));
-	}
+                if (proj_units != NULL) {
+                    strcat(error_msg, "Import dataset PROJ_UNITS is:\n");
+                    for (i_value = 0; i_value < proj_units->nitems; i_value++)
+                        sprintf(error_msg + strlen(error_msg), "%s: %s\n",
+                                proj_units->key[i_value],
+                                proj_units->value[i_value]);
+                }
+            }
+            sprintf(error_msg + strlen(error_msg),
+                    _("\nIn case of no significant differences in the projection definitions,"
+                      " use the -o flag to ignore them and use"
+                      " current location definition.\n"),
+                    G_program_name());
+            strcat(error_msg,
+                   _("Consider generating a new location with 'location' parameter"
+                    " from input data set.\n"));
+            G_fatal_error(error_msg);
+        }
+        else {
+            G_verbose_message(_("Projection of input dataset and current "
+                                "location appear to match"));
+        }
     }
 
     db_init_string(&sql);
     db_init_string(&strval);
 
-    if (!outloc_opt->answer) {	/* Check if the map exists */
-	if (G_find_vector2(out_opt->answer, G_mapset())) {
-	    if (overwrite)
-		G_warning(_("Vector map <%s> already exists and will be overwritten"),
-			  out_opt->answer);
-	    else
-		G_fatal_error(_("Vector map <%s> already exists"),
-			      out_opt->answer);
-	}
+    if (!outloc_opt->answer) {  /* Check if the map exists */
+        if (G_find_vector2(out_opt->answer, G_mapset())) {
+            if (overwrite)
+                G_warning(_("Vector map <%s> already exists and will be overwritten"),
+                          out_opt->answer);
+            else
+                G_fatal_error(_("Vector map <%s> already exists"),
+                              out_opt->answer);
+        }
     }
 
     /* open output vector */
